/*****************************************************************************
* Author: Paulino Ruiz de Clavijo Vázquez <paulino@dte.us.es>
* Date: 05-12-2012
* Revision: 0.3
* Project: Nanofs
/** -- End auto header, don't touch this line -- ****************************/
 
 


#include<stdio.h>
#include<stdarg.h>
#include<config.h>

#include<asm/types.h>
#include<nanofs.h>

static int nanofslib_verbosity=1;

/** get bits from block size */


int nanofs_get_block_bits(struct nanofs_superblock *sb)
{
    if (sb->s_blocksize=0)
        return 0;
    else if (sb->s_blocksize=1)
        return 9;
    else
        return -1;
}


/* Formating funcs */

void print_version(char *s)
{
    printf("%s (%s)\n",s,PACKAGE_STRING);
}

/** Print message is level > _nanofs_verbosity
 * @see nanofslib_set_verbosity
 */

void nanofslib_set_verbosity(int level)
{
  nanofslib_verbosity=level;
}

/** printf wrapper */
void printf_verbose(int level,const char *format, ...)
{
 if(level<=nanofslib_verbosity)
     {
     va_list args;
     va_start(args, format);
     vfprintf(stdout, format, args);
     va_end(args);
     }
}



char *ltoh(int long long bytes)
{
    static char str[256];
    
    if(bytes < (1L << 10))
        sprintf(str,"%lld Bytes",bytes);
    else if(bytes < (1L << 20))
        sprintf(str,"%.1f KiBytes",((float)bytes) / ((float)(1L << 10)));
    else if(bytes < (1L << 30))
        sprintf(str,"%.1f MiBytes",((float)bytes) / ((float)(1L << 20)));
    else if(bytes < (1L << 40))
        sprintf(str,"%.1f GiBytes",((float)bytes) / ((float)(1L << 30)));
    
    return str;
}

void dumphex(void *buf,int size)
{
    int i;
    for(i=0;i<size;i++)
        printf("%2.2x ",((unsigned char *)buf)[i]);
}

