#!/bin/bash
# Run this test as root!

#set -o verbose

MNT_DIR=/tmp/mnt_nanofs
FILE=file1.txt
RES=0

if [ ! -f nanofs.raw ]; then
    echo "*** Error, run test1 first "
    exit 255
fi

echo "Preparing filesystem with mk.nanofs:"
../progs/mkfs.nanofs nanofs.raw || exit 255
echo "Adding one file into the new filesystem"
../progs/nanofs-manager nanofs.raw put file1.txt || exit 255

[ -d /tmp/mnt_nanofs ] || mkdir /tmp/mnt_nanofs

#Clear caches
echo "Clear caches..."
sync; echo 3 > /proc/sys/vm/drop_caches
echo "Loading module..."

insmod ../kernel/nanofs.ko || echo "** Error cannot load module ../kernel/nanofs.ko"

echo "Mounting loop device.."
if ( ! mount -t nanofs -oro nanofs.raw /tmp/mnt_nanofs -oloop ) then
 echo "** Error, mount failed " 
 rmmod nanofs
 exit 255
fi

echo "Listing root dir"
echo "==================="
#ls $MNT_DIR
echo ""
echo "Full list dir"
echo "==================="
#ls -la $MNT_DIR
echo ""
echo "Dump file contents"
echo "==================="
#ls /mnt
#ls -la /mnt
#stat /mnt/hi.txt
cat $MNT_DIR/$FILE
echo ""
if ( ! cmp $MNT_DIR/$FILE $FILE) then
  echo "** Error, file contents in nanofs is different"
  RES=255
fi

echo "Unmounting loop device"
umount /tmp/mnt_nanofs
echo "Removing kernel module"
rmmod nanofs
echo "All done!"
exit $RES