#!/bin/sh

MANAGER=../progs/nanofs-manager
MKFS=../progs/mkfs.nanofs
fail() {
    echo "**** Test Failed !!"
    exit 255
}



echo "### Start test 2: Testing nanofs-manager"

if [ ! -f nanofs.raw ] ; then
  echo "## Creating empty file to test filesystem (1MiB)"
  dd if=/dev/zero of=nanofs.raw bs=1M count=1 > /dev/null
else
  echo "## Using file nanofs.raw"
fi
echo "## Creating new filesystem in 'nanofs.raw'"
$MKFS nanofs.raw

echo "## Copy files to new filesystem"
$MANAGER -v nanofs.raw put test1.sh /
$MANAGER -v nanofs.raw put test2.sh /
$MANAGER -v nanofs.raw put ../configure /
echo "## List files"
$MANAGER nanofs.raw ls /
echo "## Comparing files"

$MANAGER nanofs.raw get test1.sh tmp.file
cmp test1.sh tmp.file || fail
echo "test1.sh\t[Ok]"    

$MANAGER nanofs.raw get configure tmp.file
cmp ../configure tmp.file || fail
echo "configure\t[Ok]"    

$MANAGER nanofs.raw get test2.sh tmp.file
cmp test2.sh tmp.file || fail
echo "test2.sh\t[Ok]"
rm tmp.file    

echo "### Testing 'rm' files"

$MANAGER nanofs.raw rm /test1.sh || fail
$MANAGER nanofs.raw rm /configure || fail
$MANAGER nanofs.raw rm /test2.sh || fail


echo "### End test 2"

